# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""
Python bindings to DLite


"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _dlite
else:
    import _dlite

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)



def _get_storage_base():
    return _dlite._get_storage_base()

def _get_mapping_base():
    return _dlite._get_mapping_base()

def _get_DLiteError():
    return _dlite._get_DLiteError()

def _get_DLiteVerifyError():
    return _dlite._get_DLiteVerifyError()

DLiteError = _dlite._get_DLiteError()
DLiteVerifyError = _dlite._get_DLiteVerifyError()
DLiteStorageBase = _dlite._get_storage_base()
DLiteMappingBase = _dlite._get_mapping_base()


def get_version():
    r"""
    get_version() -> char const *
    Returns the current version of DLite.

    """
    return _dlite.get_version()

def get_license():
    r"""
    get_license() -> char const *
    Returns DLite licenses information.

    """
    return _dlite.get_license()

def get_uuid(id=None):
    r"""
    get_uuid(id=None)
    Returns an UUID, depending on:

    - If ``id`` is NULL or empty, generates a new random version 4 UUID.
    - If ``id`` is not a valid UUID string, generates a new version 5 sha1-based
      UUID from ``id`` using the DNS namespace.

    Otherwise return ``id`` (which already must be a valid UUID).

    """
    return _dlite.get_uuid(id)

def get_uuid_version(id=None):
    r"""
    get_uuid_version(id=None) -> posstatus_t
    Returns the generated UUID version number if ``id`` had been passed to
    get_uuid() or zero if ``id`` is already a valid UUID.

    """
    return _dlite.get_uuid_version(id)

def join_meta_uri(name, version, namespace):
    r"""
    join_meta_uri(name, version, namespace) -> char *
    Returns a (metadata) uri by combining ``name``, ``version`` and ``namespace`` as:

        namespace/version/name

    """
    return _dlite.join_meta_uri(name, version, namespace)

def split_meta_uri(uri):
    r"""
    split_meta_uri(uri) -> status_t
    Returns (name, version, namespace)-tuplet from valid metadata ``uri``.

    """
    return _dlite.split_meta_uri(uri)

def join_url(driver, location, options=None, fragment=None):
    r"""
    join_url(driver, location, options=None, fragment=None) -> char *
    Returns an url constructed from the arguments of the form:

        driver://location?options#fragment

    The ``driver``, ``options`` and ``fragment`` arguments may be None.

    """
    return _dlite.join_url(driver, location, options, fragment)

def split_url(url):
    r"""
    split_url(url) -> status_t
    Returns a (driver, location, options, fragment)-tuplet by splitting
    ``url`` of the form

        driver://location?options#fragment

    into four parts.

    """
    return _dlite.split_url(url)

def globmatch(pattern, s):
    r"""
    globmatch(pattern, s) -> int
    Match string 's' against glob pattern 'pattern' and return zero on
    match.

    Understands the following patterns:

    - ``*``: Any number of characters.
    - ``?``: Any single character.
    - ``[a-z]``: Any single character in the range a-z.
    - ``[^a-z]``: Any single character not in the range a-z.
    - ``\x``: Match x.

    """
    return _dlite.globmatch(pattern, s)

def errclr():
    r"""
    errclr()
    Clear the last error (setting its error code to zero).

    """
    return _dlite.errclr()

def errval():
    r"""
    errval() -> int
    Returns the error code (error value) or the last error or zero if no errors
    have occured since the last call to dlite.errclr().

    """
    return _dlite.errval()

def errmsg():
    r"""
    errmsg() -> char const *
    Returns the error message of the last error.  None is returned if no errors
    have occured since the last call to dlite.errclr().

    """
    return _dlite.errmsg()

def err_get_stream():
    r"""err_get_stream() -> FILE *"""
    return _dlite.err_get_stream()

def err_set_stream(arg1):
    r"""err_set_stream(arg1)"""
    return _dlite.err_set_stream(arg1)

def err_set_file(filename):
    r"""
    err_set_file(filename)
    Set error log file. Special values includes:

    - ``None`` or empty: Turn off error output.
    - ``<stderr>``: Standard error.
    - ``<stdout>``: Standard output.

    All other values are treated as a filename that will be opened in append mode.

    """
    return _dlite.err_set_file(filename)

def asbool(str):
    r"""
    asbool(str) -> bool
    Set error stream.

    """
    return _dlite.asbool(str)


class err():
    """Context manager for temporary turning off or redirecting errors.

    By default errors are skipped within the err context. But if
    ``filename`` is provided, the error messages are written to that file.
    Special file names includes:

    - ``None`` or empty: No output is written.
    - ``<stderr>``: Write errors to stderr (default).
    - ``<stdout>``: Write errors to stdout.

    """
    def __init__(self, filename=None):
        self.filename = filename

    def __enter__(self):
        self.f = _dlite.err_get_stream()
        _dlite.err_set_file(self.filename)
        return self.f

    def __exit__(self, *exc):
        _dlite.errclr()
        _dlite.err_set_stream(self.f)

silent = err()

BlobType = _dlite.BlobType

BoolType = _dlite.BoolType

IntType = _dlite.IntType

UIntType = _dlite.UIntType

FloatType = _dlite.FloatType

FixStringType = _dlite.FixStringType

StringPtrType = _dlite.StringPtrType

DimensionType = _dlite.DimensionType

PropertyType = _dlite.PropertyType

RelationType = _dlite.RelationType


def from_typename(typename):
    r"""from_typename(typename) -> status_t"""
    return _dlite.from_typename(typename)

def to_typename(type, size):
    r"""to_typename(type, size) -> char *"""
    return _dlite.to_typename(type, size)

def get_alignment(type, size):
    r"""get_alignment(type, size) -> size_t"""
    return _dlite.get_alignment(type, size)
class StorageIterator(object):
    r"""
    Iterates over instances in storage ``s``.  If ``pattern`` is given, only
    instances whos metadata URI matches ``pattern`` are returned.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    s = property(_dlite.StorageIterator_s_get, _dlite.StorageIterator_s_set, doc=r"""s""")
    state = property(_dlite.StorageIterator_state_get, _dlite.StorageIterator_state_set, doc=r"""state""")

    def __init__(self, s, pattern=None):
        r"""
        __init__(self, s, pattern=None) -> StorageIterator
        Iterates over instances in storage ``s``.  If ``pattern`` is given, only
        instances whos metadata URI matches ``pattern`` are returned.

        """
        _dlite.StorageIterator_swiginit(self, _dlite.new_StorageIterator(s, pattern))
    __swig_destroy__ = _dlite.delete_StorageIterator

    def next(self):
        r"""
        next(self) -> Instance
        Returns next instance or None if exhausted.
        """
        return _dlite.StorageIterator_next(self)

    def __iter__(self):
        r"""__iter__(self) -> StorageIterator"""
        return _dlite.StorageIterator___iter__(self)

    def __next__(self):
        inst = self.next()
        if not inst:
            raise StopIteration()
        return inst


# Register StorageIterator in _dlite:
_dlite.StorageIterator_swigregister(StorageIterator)
IDTranslateToUUID = _dlite.IDTranslateToUUID

IDRequireUUID = _dlite.IDRequireUUID

IDKeepID = _dlite.IDKeepID

class Storage(object):
    r"""
    Represents a data storage.

    Parameters
    ----------
    driver_or_url : string
        Name of driver used to connect to the storage or, if ``location`` is not
        given, the URL to the storage:

            driver://location?options

    location : string
        The location to the storage. For file storages, this is the file name.
    options : string
        Additional options passed to the driver as a list of semicolon-separated
        ``key=value`` pairs. Each driver may have their own options. Some
        common options are:

        - ``mode={'append','r','w'}``:
          - 'append': Append to existing storage or create a new one (hdf5,json).
        - ``compact={'yes','no'}``: Whether to store in a compact format (json).
        - ``meta={'yes','no'}``: Whether to format output as metadata (json).


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    location = property(_dlite.Storage_location_get, doc=r"""location""")
    options = property(_dlite.Storage_options_get, doc=r"""options""")
    flags = property(_dlite.Storage_flags_get, doc=r"""flags""")
    idflag = property(_dlite.Storage_idflag_get, doc=r"""idflag""")

    def __init__(self, driver_or_url, location=None, options=None):
        r"""
        __init__(self, driver_or_url, location=None, options=None) -> Storage
        Represents a data storage.

        Parameters
        ----------
        driver_or_url : string
            Name of driver used to connect to the storage or, if ``location`` is not
            given, the URL to the storage:

                driver://location?options

        location : string
            The location to the storage. For file storages, this is the file name.
        options : string
            Additional options passed to the driver as a list of semicolon-separated
            ``key=value`` pairs. Each driver may have their own options. Some
            common options are:

            - ``mode={'append','r','w'}``:
              - 'append': Append to existing storage or create a new one (hdf5,json).
            - ``compact={'yes','no'}``: Whether to store in a compact format (json).
            - ``meta={'yes','no'}``: Whether to format output as metadata (json).


        """
        _dlite.Storage_swiginit(self, _dlite.new_Storage(driver_or_url, location, options))
    __swig_destroy__ = _dlite.delete_Storage

    def flush(self):
        r"""
        flush(self)
        Flush storage.
        """
        return _dlite.Storage_flush(self)

    def delete(self, id):
        r"""
        delete(self, id)
        Delete instance with given `id`.
        """
        return _dlite.Storage_delete(self, id)

    def get_driver(self):
        r"""
        get_driver(self) -> char const *
        Returns name of driver for this storage.
        """
        return _dlite.Storage_get_driver(self)

    def help(self):
        r"""
        help(self) -> char *
        Returns documentation for storage plugin.
        """
        return _dlite.Storage_help(self)

    def get_uuids(self, pattern=None):
        r"""
        get_uuids(self, pattern=None) -> char **
        Returns a list of UUIDs of all instances in the storage whos metadata matches ``pattern``. If ``pattern`` is None, all UUIDs will be returned.
        """
        return _dlite.Storage_get_uuids(self, pattern)

    def _get_readable(self):
        r"""
        _get_readable(self) -> bool
        Returns whether the storage is readable.
        """
        return _dlite.Storage__get_readable(self)

    def _set_readable(self, readable):
        r"""
        _set_readable(self, readable)
        Set storage readability.
        """
        return _dlite.Storage__set_readable(self, readable)

    def _get_writable(self):
        r"""
        _get_writable(self) -> bool
        Returns whether the storage is writable.
        """
        return _dlite.Storage__get_writable(self)

    def _set_writable(self, writable):
        r"""
        _set_writable(self, writable)
        Set storage writability.
        """
        return _dlite.Storage__set_writable(self, writable)

    def _get_generic(self):
        r"""
        _get_generic(self) -> bool
        Returns whether the storage is generic.
        """
        return _dlite.Storage__get_generic(self)

    def _set_generic(self, generic):
        r"""
        _set_generic(self, generic)
        Set whether storage is generic
        """
        return _dlite.Storage__set_generic(self, generic)

          # Override default __init__()
    def __init__(self, driver_or_url, location=None, options=None):
        loc = str(location) if location else None
        _dlite.Instance_swiginit(self, _dlite.new_Storage(
            driver_or_url=driver_or_url, location=loc, options=options))

    def __enter__(self):
        return self

    def __exit__(self, *exc):
        del self.this

    def __repr__(self):
        return (
            f"Storage('{self.driver}', location='{self.location}', "
            f"options='{self.options}')"
        )

    def __iter__(self):
        return StorageIterator(self)

    readable = property(
        fget=lambda self: self._get_readable(),
        doc="Whether the storage is readable.")

    writable = property(
        fget=lambda self: self._get_writable(),
        doc="Whether the storage is writable.")

    generic = property(
        fget=lambda self: self._get_generic(),
        doc="Whether the storage is generic, i.e. whether the storage can "
        "hold multiple instances, including both data and metadata."
    )

    @classmethod
    def create_from_url(cls, url):
        """Create a new storage from `url`."""
        return cls(url)

    def instances(self, pattern=None):
        """Returns an iterator over all instances in storage whos
        metadata URI matches `pattern`."""
        return StorageIterator(self, pattern=pattern)

    def load(self, id, metaid=None):
        """Loads instance `id` from this storage and return it.

        If `metaid` is provided, the returned instance will be
        mapped to an instance of this type (if appropriate mappings
        are available)."""
        return Instance.from_storage(self, id, metaid)

    def save(self, inst):
        """Stores instance `inst` in this storage."""
        inst.save_to_storage(self)

    driver = property(get_driver,
                      doc='Name of driver associated with this storage')


# Register Storage in _dlite:
_dlite.Storage_swigregister(Storage)
class StoragePluginIter(object):
    r"""
    Iterates over loaded storage plugins.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    iter = property(_dlite.StoragePluginIter_iter_get, _dlite.StoragePluginIter_iter_set, doc=r"""iter""")

    def __init__(self):
        r"""
        __init__(self) -> StoragePluginIter
        Iterates over loaded storage plugins.

        """
        _dlite.StoragePluginIter_swiginit(self, _dlite.new_StoragePluginIter())
    __swig_destroy__ = _dlite.delete_StoragePluginIter

    def next(self):
        r"""
        next(self) -> char const *
        Returns name of next plugin or None if exhausted.

        """
        return _dlite.StoragePluginIter_next(self)

    def __iter__(self):
        r"""__iter__(self) -> StoragePluginIter"""
        return _dlite.StoragePluginIter___iter__(self)

    def __next__(self):
        name = self.next()
        if not name:
            raise StopIteration()
        return name


# Register StoragePluginIter in _dlite:
_dlite.StoragePluginIter_swigregister(StoragePluginIter)

def storage_unload(name):
    r"""storage_unload(name) -> int"""
    return _dlite.storage_unload(name)
class Dimension(object):
    r"""Proxy of C _DLiteDimension struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    name = property(_dlite.Dimension_name_get, _dlite.Dimension_name_set, doc=r"""name""")
    description = property(_dlite.Dimension_description_get, _dlite.Dimension_description_set, doc=r"""description""")

    def __init__(self, name, description=None):
        r"""__init__(self, name, description=None) -> Dimension"""
        _dlite.Dimension_swiginit(self, _dlite.new_Dimension(name, description))
    __swig_destroy__ = _dlite.delete_Dimension

    def __repr__(self):
        return 'Dimension(name=%r, description=%r)' % (
            self.name, self.description)

    def asdict(self):
        """Returns a dict representation of self."""
        d = OrderedDict()
        d['name'] = self.name
        if self.description:
            d['description'] = self.description
        return d

    def asstrings(self):
        """Returns a representation of self as a tuple of strings."""
        return (self.name,
                '' if self.description is None else self.description)


# Register Dimension in _dlite:
_dlite.Dimension_swigregister(Dimension)
class Property(object):
    r"""
    Creates a new property with the provided attributes.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    name = property(_dlite.Property_name_get, _dlite.Property_name_set, doc=r"""name""")
    size = property(_dlite.Property_size_get, _dlite.Property_size_set, doc=r"""size""")
    ref = property(_dlite.Property_ref_get, _dlite.Property_ref_set, doc=r"""ref""")
    ndims = property(_dlite.Property_ndims_get, doc=r"""ndims""")
    unit = property(_dlite.Property_unit_get, _dlite.Property_unit_set, doc=r"""unit""")
    description = property(_dlite.Property_description_get, _dlite.Property_description_set, doc=r"""description""")

    def __init__(self, name, type, ref=None, dims=None, unit=None, description=None):
        r"""
        __init__(self, name, type, ref=None, dims=None, unit=None, description=None) -> Property
        Creates a new property with the provided attributes.

        """
        _dlite.Property_swiginit(self, _dlite.new_Property(name, type, ref, dims, unit, description))
    __swig_destroy__ = _dlite.delete_Property

    def get_type(self):
        r"""get_type(self) -> char *"""
        return _dlite.Property_get_type(self)

    def get_dtype(self):
        r"""get_dtype(self) -> int"""
        return _dlite.Property_get_dtype(self)

    def get_shape(self):
        r"""get_shape(self) -> obj_t *"""
        return _dlite.Property_get_shape(self)

    def set_shape(self, arr):
        r"""set_shape(self, arr)"""
        return _dlite.Property_set_shape(self, arr)

    def __repr__(self):
        ref = ', ref=%r' % self.ref if self.ref else ''
        shape = ', shape=%r' % self.shape.tolist() if self.ndims else ''
        unit = ', unit=%r' % self.unit if self.unit else ''
        descr = ', description=%r' %self.description if self.description else ''
        return 'Property(%r, type=%r%s%s%s%s)' % (
            self.name, self.type, ref, shape, unit, descr)

    def asdict(self, soft7=True, exclude_name=False):
        """Returns a dict representation of self.

        Args:
            soft7: Whether to use new SOFT7 format.
            exclude_name: Whether to exclude "name" from the returned dict.
        """
        d = OrderedDict()
        if not exclude_name:
            d['name'] = self.name
        d['type'] = self.get_type()
        if self.ref:
            d['ref'] = self.ref
        if self.ndims:
            d['shape' if soft7 else 'dims'] = self.shape.tolist()
        if self.unit:
            d['unit'] = self.unit
        if self.description:
            d['description'] = self.description
        return d

    def asstrings(self):
        """Returns a representation of self as a tuple of strings."""
        return (self.name, self.type, ','.join(str(d) for d in self.shape),
                '' if self.unit is None else self.unit,
                '' if self.description is None else self.description)

    type = property(get_type, doc='Type name.')
    dtype = property(get_dtype, doc='Type number.')
    shape = property(get_shape, set_shape, doc='Array of dimension indices.')

    # Too be removed...
    def _get_dims_depr(self):
        warnings.warn('Property `dims` is deprecated, use `shape` instead.',
                      DeprecationWarning, stacklevel=2)
        return self.get_shape()
    dims = property(_get_dims_depr, doc='Array of dimension indices. '
                    'Property `dims` is deprecated, use `shape` instead.')



# Register Property in _dlite:
_dlite.Property_swigregister(Property)
class Relation(object):
    r"""Proxy of C _Triple struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    s = property(_dlite.Relation_s_get, _dlite.Relation_s_set, doc=r"""s""")
    p = property(_dlite.Relation_p_get, _dlite.Relation_p_set, doc=r"""p""")
    o = property(_dlite.Relation_o_get, _dlite.Relation_o_set, doc=r"""o""")
    id = property(_dlite.Relation_id_get, _dlite.Relation_id_set, doc=r"""id""")

    def __init__(self, s, p, o, id=None):
        r"""__init__(self, s, p, o, id=None) -> Relation"""
        _dlite.Relation_swiginit(self, _dlite.new_Relation(s, p, o, id))
    __swig_destroy__ = _dlite.delete_Relation

    def __repr__(self):
        return 'Relation(s=%r, p=%r, o=%r, id=%r)' % (
            self.s, self.p, self.o, self.id)

    def aspreferred(self):
        """Returns preferred Python representation."""
        return self.asstrings()

    def asdict(self):
        """Returns a dict representation of self."""
        if self.id:
            d = OrderedDict(s=self.s, p=self.p, o=self.o, id=self.id)
        else:
            d = OrderedDict(s=self.s, p=self.p, o=self.o)
        return d

    def asstrings(self):
        """Returns a representation of self as a tuple of strings."""
        return (self.s, self.p, self.o)


# Register Relation in _dlite:
_dlite.Relation_swigregister(Relation)

def triple_get_id(s, p, o, namespace=None):
    r"""triple_get_id(s, p, o, namespace=None) -> char *"""
    return _dlite.triple_get_id(s, p, o, namespace)

def triple_set_default_namespace(namespace):
    r"""triple_set_default_namespace(namespace)"""
    return _dlite.triple_set_default_namespace(namespace)
class Instance(object):
    r"""
    Returns a new instance.

    Instance(metaid=None, dims=None, id=None, url=None, storage=None, driver=None, location=None, options=None, dimensions=None, properties=None, description=None)
        Is called from one of the following class methods defined in dlite.py:

          - from_metaid(cls, metaid, dims, id=None)
          - from_url(cls, url, metaid=None)
          - from_storage(cls, storage, id=None, metaid=None)
          - from_location(cls, driver, location, options=None, id=None)
          - from_json(cls, jsoninput, id=None, metaid=None)
          - from_bson(cls, bsoninput)
          - from_dict(cls, d, id=None, single=None, check_storages=True)
          - create_metadata(cls, uri, dimensions, properties, description)

          For details, see the documentation for the class methods.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    uuid = property(_dlite.Instance_uuid_get, doc=r"""uuid""")
    _flags = property(_dlite.Instance__flags_get, doc=r"""_flags""")
    uri = property(_dlite.Instance_uri_get, doc=r"""uri""")
    _refcount = property(_dlite.Instance__refcount_get, doc=r"""_refcount""")

    def __init__(self, metaid=None, dims=None, id=None, url=None, storage=None, driver=None, location=None, options=None, uri=None, jsoninput=None, bsoninput=None, dimensions=None, properties=None, description=None):
        r"""
        __init__(self, metaid=None, dims=None, id=None, url=None, storage=None, driver=None, location=None, options=None, uri=None, jsoninput=None, bsoninput=None, dimensions=None, properties=None, description=None) -> Instance
        Returns a new instance.

        Instance(metaid=None, dims=None, id=None, url=None, storage=None, driver=None, location=None, options=None, dimensions=None, properties=None, description=None)
            Is called from one of the following class methods defined in dlite.py:

              - from_metaid(cls, metaid, dims, id=None)
              - from_url(cls, url, metaid=None)
              - from_storage(cls, storage, id=None, metaid=None)
              - from_location(cls, driver, location, options=None, id=None)
              - from_json(cls, jsoninput, id=None, metaid=None)
              - from_bson(cls, bsoninput)
              - from_dict(cls, d, id=None, single=None, check_storages=True)
              - create_metadata(cls, uri, dimensions, properties, description)

              For details, see the documentation for the class methods.


        """
        _dlite.Instance_swiginit(self, _dlite.new_Instance(metaid, dims, id, url, storage, driver, location, options, uri, jsoninput, bsoninput, dimensions, properties, description))
    __swig_destroy__ = _dlite.delete_Instance

    def _get_meta(self):
        r"""
        _get_meta(self) -> Instance
        Returns reference to metadata.
        """
        return _dlite.Instance__get_meta(self)

    def _get_parent_uuid(self):
        r"""
        _get_parent_uuid(self) -> char const *
        Returns reference to parent uuid.
        """
        return _dlite.Instance__get_parent_uuid(self)

    def _get_parent_hash(self):
        r"""
        _get_parent_hash(self) -> char *
        Returns reference to parent hash.
        """
        return _dlite.Instance__get_parent_hash(self)

    def save(self, driver_or_url=None, location=None, options=None, storage=None):
        r"""
        save(self, driver_or_url=None, location=None, options=None, storage=None)
        Saves this instance to url or storage.

        Call signatures:
            save(url)
            save(driver, location, options=None)
            save(storage=storage)

        """
        return _dlite.Instance_save(self, driver_or_url, location, options, storage)

    def save_to_url(self, url):
        r"""save_to_url(self, url)"""
        return _dlite.Instance_save_to_url(self, url)

    def save_to_storage(self, storage):
        r"""save_to_storage(self, storage)"""
        return _dlite.Instance_save_to_storage(self, storage)

    def to_bytes(self, driver):
        r"""
        to_bytes(self, driver)
        Save instance to bytes using given storage driver.
        """
        return _dlite.Instance_to_bytes(self, driver)

    def get_hash(self):
        r"""
        get_hash(self) -> char *
        Returns a hash of the instance.
        """
        return _dlite.Instance_get_hash(self)

    def verify_hash(self, hash=None, recursive=False):
        r"""
        verify_hash(self, hash=None, recursive=False)
        Verify the hash of the instance.

        If `hash` is not None, this function verifies that the hash of
        `inst` corresponds to the memory pointed to by `hash`.  The size
        of the memory should be `DLITE_HASH_SIZE` bytes.

        If `hash` is None and `inst` has a parent, this function will
        instead verify that the parent hash stored in `inst` corresponds
        to the value of the parent.

        If `recursive` is true, all ancestors of `inst` are also
        included in the verification.

        Raises a DLiteVerifyError exception if the hash is not valid.
        """
        return _dlite.Instance_verify_hash(self, hash, recursive)

    def copy(self, newid=None):
        r"""
        copy(self, newid=None) -> Instance
        Returns a copy of the instance.  If `newid` is given, it will be
        the id of the new instance, otherwise it will be given a
        random UUID.
        """
        return _dlite.Instance_copy(self, newid)

    def snapshot(self):
        r"""
        snapshot(self)
        Make a snapshot of the current state of the instance.  It can
        be retrieved with `get_snapshot()`.

        The instance will be a transaction whose parent is the snapshot.
        If `inst` already has a parent, that will now be the parent of
        the snapshot.

        The reason that `inst` must be mutable, is that its hash will
        change due to a change in its parent.

        The snapshot will be assigned an URI of the form
        "snapshot-XXXXXXXXXXXX" (or inst->uri#snapshot-XXXXXXXXXXXX
        if inst->uri is not NULL) where each X is replaces with a
        random character.
        """
        return _dlite.Instance_snapshot(self)

    def get_snapshot(self, n=1):
        r"""
        get_snapshot(self, n=1) -> Instance
        Returns shapshot number `n` of the current instance, where `n`
        counts backward.  Hence, `n=0` returns the current instance,
        `n=1` returns its parent, etc...

        This function may pull snapshots back into memory. Use
        `dlite_instance_pull()` if you know the storage where the snapshots are stored.
        """
        return _dlite.Instance_get_snapshot(self, n)

    def pull_snapshot(self, storage, n):
        r"""
        pull_snapshot(self, storage, n) -> Instance
        Like `dlite_instance_get_snapshot()`, except that possible stored
        snapshots are pulled from a specified storage to memory.

        Returns shapshot number `n` of the current instance, where `n`
        counts backward.  Hence, `n=0` returns the current instance,
        `n=1` returns its parent, etc... 
        """
        return _dlite.Instance_pull_snapshot(self, storage, n)

    def push_snapshot(self, storage, n):
        r"""
        push_snapshot(self, storage, n)
        Push all ancestors of snapshot `n` from memory to storage,
        where `n=0` corresponds to `inst`, `n=1` to the parent of
        `inst`, etc...

        No snapshot is pulled back from storage, so if the snapshots are
        already in storage, this function has no effect.

        This function starts pushing closest to the root to ensure
        that the transaction is in a consistent state at all times.
        """
        return _dlite.Instance_push_snapshot(self, storage, n)

    def set_parent(self, parent):
        r"""
        set_parent(self, parent)
        Turn instance `inst` into a transaction node with parent
        `parent`.  This requires that `inst` is mutable, and `parent`
        is immutable.  If `inst` already has a parent, it will be
        replaced.

        Use `dlite_instance_freeze()` and `dlite_instance_is_frozen()` to
        make and check that an instance is immutable, respectively.
        """
        return _dlite.Instance_set_parent(self, parent)

    def freeze(self):
        r"""
        freeze(self)
        Mark the instance as immutable.  This can never be reverted.
        """
        return _dlite.Instance_freeze(self)

    def is_frozen(self):
        r"""
        is_frozen(self) -> bool
        Returns whether the instance is frozen and immutable.
        """
        return _dlite.Instance_is_frozen(self)

    def verify_transaction(self):
        r"""
        verify_transaction(self) -> bool
        Verifies a transaction.
        """
        return _dlite.Instance_verify_transaction(self)

    def get_dimensions(self):
        r"""
        get_dimensions(self) -> obj_t *
        Returns array with dimension sizes.
        """
        return _dlite.Instance_get_dimensions(self)

    def get_dimension_size(self, name):
        r"""
        get_dimension_size(self, name) -> int
        Returns the size of dimension with given name or index.
        """
        return _dlite.Instance_get_dimension_size(self, name)

    def get_dimension_size_by_index(self, i):
        r"""get_dimension_size_by_index(self, i) -> int"""
        return _dlite.Instance_get_dimension_size_by_index(self, i)

    def get_property(self, name):
        r"""
        get_property(self, name) -> obj_t *
        Returns property with given name.
        """
        return _dlite.Instance_get_property(self, name)

    def get_property_by_index(self, i):
        r"""
        get_property_by_index(self, i) -> obj_t *
        Returns property with given index.
        """
        return _dlite.Instance_get_property_by_index(self, i)

    def set_property(self, name, obj):
        r"""
        set_property(self, name, obj)
        Sets property with given name to `obj`.
        """
        return _dlite.Instance_set_property(self, name, obj)

    def set_property_by_index(self, i, obj):
        r"""
        set_property_by_index(self, i, obj)
        Sets property with given index to `obj`.
        """
        return _dlite.Instance_set_property_by_index(self, i, obj)

    def get_property_as_string(self, name, width=0, prec=-2, flags=0):
        r"""
        get_property_as_string(self, name, width=0, prec=-2, flags=0) -> char *
        Return property ``name`` as a string.

        Parameters:
            width: Minimum field width. Unused if 0, auto if -1.
            prec: Precision. Auto if -1, unused if -2.
            flags: Or'ed sum of formatting flags:

                - ``0``: Default (json).
                - ``1``: Raw unquoted output.
                - ``2``: Quoted output.

        Returns:
            Property as a string.


        """
        return _dlite.Instance_get_property_as_string(self, name, width, prec, flags)

    def set_property_from_string(self, name, s, flags=0):
        r"""
        set_property_from_string(self, name, s, flags=0)
        Set property `name` to the value of string `s`. 

        `flags` is the or'ed sum of:
          0  default (json)
          1  raw unquoted input
          2  quoted input
          4  strip initial and final spaces
        """
        return _dlite.Instance_set_property_from_string(self, name, s, flags)

    def has_property(self, name):
        r"""
        has_property(self, name) -> bool
        Returns true if this instance has a property with given name.
        """
        return _dlite.Instance_has_property(self, name)

    def has_property_by_index(self, i):
        r"""
        has_property_by_index(self, i) -> bool
        Returns true if this instance has a property with given index.
        """
        return _dlite.Instance_has_property_by_index(self, i)

    def has_dimension(self, name):
        r"""
        has_dimension(self, name) -> bool
        Returns true if this instance has a dimension with given name.
        """
        return _dlite.Instance_has_dimension(self, name)

    def has_dimension_by_index(self, i):
        r"""
        has_dimension_by_index(self, i) -> bool
        Returns true if this instance has a dimension with given index.
        """
        return _dlite.Instance_has_dimension_by_index(self, i)

    def _is_data(self):
        r"""
        _is_data(self) -> bool
        Returns true if this is a data instance.
        """
        return _dlite.Instance__is_data(self)

    def _is_meta(self):
        r"""
        _is_meta(self) -> bool
        Returns true if this is metadata.
        """
        return _dlite.Instance__is_meta(self)

    def _is_metameta(self):
        r"""
        _is_metameta(self) -> bool
        Returns true if this is meta-metadata.
        """
        return _dlite.Instance__is_metameta(self)

    def _incref(self):
        r"""
        _incref(self) -> int
        Increase reference count and return the new refcount.
        """
        return _dlite.Instance__incref(self)

    def _decref(self):
        r"""
        _decref(self) -> int
        Decrease reference count and return the new refcount.
        """
        return _dlite.Instance__decref(self)

    def _asjson(self, indent=0, single=False, urikey=False, with_uuid=False, with_meta=False, with_arrays=False, no_parent=False):
        r"""
        _asjson(self, indent=0, single=False, urikey=False, with_uuid=False, with_meta=False, with_arrays=False, no_parent=False) -> char *
        Returns a JSON representation of self.
        """
        return _dlite.Instance__asjson(self, indent, single, urikey, with_uuid, with_meta, with_arrays, no_parent)

    def asbson(self):
        r"""
        asbson(self)
        Returns a BSON representation of self.
        """
        return _dlite.Instance_asbson(self)

    def get_uri(self):
        r"""
        get_uri(self) -> char *
        Returns instance uri.
        """
        return _dlite.Instance_get_uri(self)

    def __len__(self):
        r"""__len__(self) -> int"""
        return _dlite.Instance___len__(self)

    def __repr__(self):
        r"""__repr__(self) -> char *"""
        return _dlite.Instance___repr__(self)

    def _c_ptr(self):
        r"""_c_ptr(self) -> PyObject *"""
        return _dlite.Instance__c_ptr(self)


        # Override default generated __init__() method
    def __init__(self, *args, **kwargs):
        if self is None:
            raise DLiteError(f"invalid dlite.Instance")

        _dlite.errclr()
        _dlite.Instance_swiginit(self, _dlite.new_Instance(*args, **kwargs))

        if not hasattr(self, 'this') or not getattr(self, 'this'):
            raise DLiteError(f"cannot initiate dlite.Instance")
        elif self.is_meta:
            self.__class__ = Metadata
        elif self.meta.uri == COLLECTION_ENTITY:
            self.__class__ = Collection

    def get_meta(self):
        """Returns reference to metadata."""
        meta = self._get_meta()
        assert meta.is_meta
        meta.__class__ = Metadata
        return meta

    def get_property_descr(self, name):
        """Return a Property object for property `name`."""
        for p in self.meta['properties']:
            if p.name == name:
                return p
        raise ValueError(f'No property "{name}" in "{self.uri}"')

    meta = property(get_meta, doc="Reference to the metadata of this instance.")
    dimensions = property(
        lambda self: OrderedDict((d.name, int(v))
                                 for d, v in zip(self.meta['dimensions'],
                                                 self.get_dimensions())),
        doc='Dictionary with dimensions name-value pairs.')
    properties = property(lambda self:
        {p.name: self[p.name] for p in self.meta['properties']},
        doc='Dictionary with property name-value pairs.')
    is_data = property(_is_data, doc='Whether this is a data instance.')
    is_meta = property(_is_meta, doc='Whether this is a metadata instance.')
    is_metameta = property(_is_metameta,
                           doc='Whether this is a meta-metadata instance.')
    namespace = property(
        lambda self: Namespace(self.get_uri() + '#'),
        doc='A tripper.Namespace reference to this instance. '
        'Note, this requires tripper to be installed.'
    )

    @classmethod
    def from_metaid(cls, metaid, dims, id=None):
        """Create a new instance of metadata `metaid`.  `dims` must be a
        sequence with the size of each dimension.  All values initialized
        to zero.  If `id` is None, a random UUID is generated.  Otherwise
        the UUID is derived from `id`.
        """
        if isinstance(dims, dict):
            meta = get_instance(metaid)
            dims = [dims[dim.name] for dim in meta.properties['dimensions']]
    # Allow metaid to be an Instance
        if isinstance(metaid, Instance):
            metaid = metaid.uri
        return Instance(
            metaid=metaid, dims=dims, id=id,
            dimensions=(), properties=()  # arrays must not be None
        )

    @classmethod
    def from_url(cls, url, metaid=None):
        """Load the instance from `url`.  The URL should be of the form
        ``driver://location?options#id``.
        If `metaid` is provided, the instance is tried mapped to this
        metadata before it is returned.
        """
        return Instance(
            url=url, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def from_storage(cls, storage, id=None, metaid=None):
        """Load the instance from `storage`.  `id` is the id of the instance
        in the storage (not required if the storage only contains more one
        instance).
        If `metaid` is provided, the instance is tried mapped to this
        metadata before it is returned.
        """
        return Instance(
            storage=storage, id=id, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def from_location(cls, driver, location, options=None, id=None):
        """Load the instance from storage specified by `driver`, `location`
        and `options`.  `id` is the id of the instance in the storage (not
        required if the storage only contains more one instance).
        """
        return Instance(
            driver=driver, location=str(location), options=options, id=id,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def from_json(cls, jsoninput, id=None, metaid=None):
        """Load the instance from json input."""
        return Instance(
            jsoninput=jsoninput, id=id, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def from_bson(cls, bsoninput):
        """Load the instance from bson input."""
        return Instance(
            bsoninput=bsoninput,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def from_dict(cls, d, id=None, single=None, check_storages=True):
        """Load the instance from dictionary."""
        from dlite.utils import instance_from_dict
        return instance_from_dict(
            d, id=id, single=single, check_storages=check_storages,
        )

    @classmethod
    def from_bytes(cls, driver, buffer, id=None):
        """Load the instance with ID `id` from bytes `buffer` using the
        given storage driver.
        """
        return _from_bytes(driver, buffer, id=id)

    @classmethod
    def create_metadata(cls, uri, dimensions, properties, description):
        """Create a new metadata entity (instance of entity schema) casted
        to an instance.
        """
        return Instance(
            uri=uri, dimensions=dimensions, properties=properties,
            description=description,
            dims=()  # arrays
        )

    @classmethod
    def create_from_metaid(cls, metaid, dims, id=None):
        """Create a new instance of metadata `metaid`.  `dims` must be a
        sequence with the size of each dimension.  All values initialized
        to zero.  If `id` is None, a random UUID is generated.  Otherwise
        the UUID is derived from `id`.
        """
        warnings.warn(
            "create_from_metaid() is deprecated, use from_metaid() instead.",
            DeprecationWarning, stacklevel=2)
        if isinstance(dims, dict):
            meta = get_instance(metaid)
            dims = [dims[dim.name] for dim in meta.properties['dimensions']]
        return Instance(
            metaid=metaid, dims=dims, id=id,
            dimensions=(), properties=()  # arrays must not be None
        )

    @classmethod
    def create_from_url(cls, url, metaid=None):
        """Load the instance from `url`.  The URL should be of the form
        ``driver://location?options#id``.
        If `metaid` is provided, the instance is tried mapped to this
        metadata before it is returned.
        """
        warnings.warn(
            "create_from_url() is deprecated, use from_url() instead.",
            DeprecationWarning, stacklevel=2)
        return Instance(
            url=url, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def create_from_storage(cls, storage, id=None, metaid=None):
        """Load the instance from `storage`.  `id` is the id of the instance
        in the storage (not required if the storage only contains more one
        instance).
        If `metaid` is provided, the instance is tried mapped to this
        metadata before it is returned.
        """
        warnings.warn(
            "create_from_storage() is deprecated, use from_storage() instead.",
            DeprecationWarning, stacklevel=2)
        return Instance(
            storage=storage, id=id, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def create_from_location(cls, driver, location, options=None, id=None):
        """Load the instance from storage specified by `driver`, `location`
        and `options`.  `id` is the id of the instance in the storage (not
        required if the storage only contains more one instance).
        """
        warnings.warn(
            "create_from_location() is deprecated, use from_location() "
            "instead.", DeprecationWarning, stacklevel=2)
        return Instance(
            driver=driver, location=str(location), options=options, id=id,
            dims=(), dimensions=(), properties=()  # arrays
        )

    def save(self, dest, location=None, options=None):
        """Saves this instance to url or storage.

        Call signatures:
          - save(url)
          - save(driver, location, options=None)
          - save(storage)
        """
        if isinstance(dest, Storage):
            self.save_to_storage(storage=dest)
        elif location:
            with Storage(dest, str(location), options) as storage:
                storage.save(self)
        elif isinstance(dest, str):
            self.save_to_url(dest)
        else:
            raise DLiteError('Arguments do not match any call signature')

    def __getitem__(self, ind):
        if isinstance(ind, int):
            value = self.get_property_by_index(ind)
        elif self.has_property(ind):
            value = self.get_property(ind)
        elif isinstance(ind, int):
            raise IndexError('instance property index out of range: %d' % ind)
        else:
            raise KeyError('no such property: %s' % ind)
        if isinstance(value, np.ndarray) and self.is_frozen():
            value.flags.writeable = False  # ensure immutability
        return value

    def __setitem__(self, ind, value):
        if self.is_frozen():
            raise DLiteError('frozen instance does not support item assignment')
        if isinstance(ind, int):
            self.set_property_by_index(ind, value)
        elif self.has_property(ind):
            self.set_property(ind, value)
        elif isinstance(ind, int):
            raise IndexError('instance property index out of range: %d' % ind)
        else:
            raise KeyError('no such property: %s' % ind)

    def __contains__(self, item):
        return item in self.properties.keys()

    def __getattr__(self, name):
        if name == 'this':
            return object.__getattribute__(self, name)
        d = object.__getattribute__(self, '__dict__')
        if name in d:
            value = d[name]
        elif self.has_property(name):
            value = _get_property(self, name)
        elif self.has_dimension(name):
            value = self.get_dimension_size(name)
        else:
            raise AttributeError('Instance object has no attribute %r' % name)
        if isinstance(value, np.ndarray) and self.is_frozen():
            value.flags.writeable = False  # ensure immutability
        return value

    def __setattr__(self, name, value):
        if name == 'this':
            object.__setattr__(self, name, value)
        elif self.is_frozen():
            raise DLiteError(
                'frozen instance does not support attribute assignment')
        elif _has_property(self, name):
            _set_property(self, name, value)
        else:
            object.__setattr__(self, name, value)

    def __dir__(self):
        return (object.__dir__(self) +
                [name for name in self.properties] +
                [d.name for d in self.meta.properties['dimensions']])

    def __hash__(self):
        return UUID(self.uuid).int

    def __eq__(self, other):
        return self.uuid == other.uuid

    def __str__(self):
        return self.asjson()

    def __reduce__(self):
    # ensures that instances can be pickled
        def iterfun(inst):
           for i, prop in enumerate(inst.properties.values()):
               if isinstance(prop, np.ndarray):
                   p = np.zeros_like(prop)
                   p.flat = [p.asdict() if hasattr(p, 'asdict') else p
                             for p in prop]
               else:
                   p = prop.asdict() if hasattr(prop, 'asdict') else prop
               yield i, p
        return (
            Instance.from_metaid,
            (self.meta.uri, list(self.dimensions.values()), self.uuid),
            None,
            None,
            iterfun(self),
        )

    def __call__(self, dimensions=(), properties=None, id=None, dims=None):
        """Returns a new instance of this metadata.

        By default the instance is uninitialised, but with the `properties`
        argument it can be either partly or fully initialised.

        Arguments:
            dimensions: Either a dict mapping dimension names to values or
                a sequence of dimension values.
            properties: Dict of property name-property value pairs.  Used
                to initialise the instance (fully or partly).  A KeyError
                is raised if a key is not a valid property name.
            id: Id of the new instance.  The default is to create a
                random UUID.
            dims: Deprecated alias for `dimensions`.

        Returns:
            New instance.
        """
        if not self.is_meta:
            raise TypeError('data instances are not callable')
        if dims is not None:
            warnings.warn(
                "`dims` argument of metadata constructor is deprecated.\n"
                "Use `dimensions` instead.",
                DeprecationWarning,
                stacklevel=2,
            )
            dimensions = dims
        if isinstance(dimensions, dict):
            dimnames = [d.name for d in self.properties['dimensions']]
            dimensions = [dimensions[name] for name in dimnames]

        inst = Instance.from_metaid(self.uri, dimensions, id)
        if isinstance(properties, dict):
            for k, v in properties.items():
                inst[k] = v
        return inst

    def asdict(self, soft7=True, uuid=True):
        """Returns a dict representation of self.

        Arguments:
            soft7: Whether to structure metadata as SOFT7.
            uuid: Whether to include UUID in the dict.
        """
        d = OrderedDict()
        if uuid:
            d['uuid'] = self.uuid
        if self.uri:
            d['uri'] = self.uri
        d['meta'] = self.meta.uri
        if self.is_meta:
            d['description'] = self['description']
            if soft7:
                d['dimensions'] = {dim.name: dim.description
                                   for dim in self['dimensions']}
                d['properties'] = {p.name: p.asdict(exclude_name=True)
                                   for p in self['properties']}
            else:
                d['dimensions'] = [dim.asdict() for dim in self['dimensions']]
                d['properties'] = [p.asdict(soft7=False)
                                   for p in self['properties']]
        else:
            d['dimensions'] = self.dimensions
            d['properties'] = {k: standardise(v, self.get_property_descr(k))
                               for k, v in self.properties.items()}
        if self.has_property('relations') and (
                self.is_meta or self.meta.has_property('relations')):
            d['relations'] = self['relations'].tolist()
        return d

    def asjson(self, indent=0, single=None,
               urikey=False, with_uuid=False, with_meta=False,
               with_arrays=False, no_parent=False,
               soft7=None, uuid=None):
        """Returns a JSON representation of self.

        Arguments:
            indent: Number of spaces to indent each line with.
            single: Whether to return single-entity format.  Default is
                single-entity format for metadata and multi-entity format
                for data instances.
            urikey: Use uri (if it exists) as JSON key in multi-entity format.
            with_uuid: Whether to include UUID in output.
            with_meta: Always include "meta" field, even for entities.
            with_arrays: Write metadata dimensions and properties as jSON
                arrays (old format).
            no_parent: Do not include transaction parent info.
            soft7: Whether to structure metadata as SOFT7. Deprecated.
                Use `with_arrays=False` instead.
            uuid: Alias for `with_uuid`. Deprecated.
        """
        if single is None:
            single = self.is_meta

        if soft7 is not None:
            warnings.warn(
                "`soft7` argument of asjson() is deprecated, use "
                "`with_arrays` (negated) instead.",
                 DeprecationWarning, stacklevel=2)
            with_arrays = not bool(soft7)

        if uuid is not None:
            warnings.warn(
                "`uuid` argument of asjson() is deprecated, use "
                "`with_uuid` instead.",
                 DeprecationWarning, stacklevel=2)
            with_uuid = bool(uuid)

        return self._asjson(indent=indent, single=single, urikey=urikey,
                            with_uuid=with_uuid, with_meta=with_meta,
                            with_arrays=with_arrays, no_parent=no_parent)


    # Deprecated methods
    def tojson(self, indent=0, single=False,
               urikey=False, with_uuid=False, with_meta=False,
               with_arrays=False, no_parent=False,
               soft7=None, uuid=None):
        """Deprecated alias for asjson()."""
        warnings.warn(
            'tojson() is deprecated, use asjson() instead.',
             DeprecationWarning, stacklevel=2)
        return self._asjson(indent=indent, single=single, urikey=urikey,
                            with_uuid=with_uuid, with_meta=with_meta,
                            with_arrays=with_arrays, no_parent=no_parent)

    def get_copy(self):
        """Returns a copy of self.

        This method is deprecated.  Use copy() instead.
        """
        warnings.warn(
            "Instance.get_copy() is deprecated.  Use Instance.copy() instead.",
            DeprecationWarning, stacklevel=2)
        return self.copy()


# Register Instance in _dlite:
_dlite.Instance_swigregister(Instance)

def get_instance(id, metaid=None, check_storages=True):
    r"""
    get_instance(id, metaid=None, check_storages=True) -> Instance
    Returns a new reference to instance with given id.

    If `metaid` is provided, the instance will be mapped to an instance of
    this metadata.

    If the instance exists in the in-memory store it is returned.
    Otherwise, if `check_storages` is true, the instance is searched for
    in the storage plugin path (initiated from the DLITE_STORAGES
    environment variable).

    It is an error message if the instance cannot be found.

    Note: seting `check_storages` to false is normally a good idea if calling
    this function from a storage plugin.  Otherwise you may easily end up in an
    infinite recursive loop that will exhaust the call stack.

    """
    return _dlite.get_instance(id, metaid, check_storages)

def has_instance(id, check_storages=True):
    r"""
    has_instance(id, check_storages=True) -> bool
    Returns whether an instance with `id` exists.

    If `check_storages` is true, the instance is also searched for
    in the storage plugin path.

    """
    return _dlite.has_instance(id, check_storages)

def istore_get_uuids():
    r"""
    istore_get_uuids() -> char **
    Returns a list of in-memory stored ids.


    """
    return _dlite.istore_get_uuids()

def _get_property(inst, name):
    r"""_get_property(inst, name) -> obj_t *"""
    return _dlite._get_property(inst, name)

def _set_property(inst, name, obj):
    r"""_set_property(inst, name, obj)"""
    return _dlite._set_property(inst, name, obj)

def _has_property(inst, name):
    r"""_has_property(inst, name) -> bool"""
    return _dlite._has_property(inst, name)

def _from_bytes(driver, INPUT_BYTES, id=None):
    r"""
    _from_bytes(driver, INPUT_BYTES, id=None) -> Instance
    Loads instance from string.
    """
    return _dlite._from_bytes(driver, INPUT_BYTES, id)
BASIC_METADATA_SCHEMA = _dlite.BASIC_METADATA_SCHEMA

ENTITY_SCHEMA = _dlite.ENTITY_SCHEMA

COLLECTION_ENTITY = _dlite.COLLECTION_ENTITY


import sys
import json
import base64
import warnings
from uuid import UUID

if sys.version_info >= (3, 7):
    OrderedDict = dict
else:
    from collections import OrderedDict

import numpy as np


class InvalidMetadataError:
    """Malformed or invalid metadata."""


class Metadata(Instance):
    """A subclass of Instance for metadata.

    Arguments:
        uri: URI of the new metadata.
        dimensions: Sequence of Dimension instances describing each dimension.
        properties: Sequence of Property instances describing each property.
        description: Description of metadata.
    """
    def __new__(
            cls,
            uri: str,
            dimensions: "Sequence[Dimension]",
            properties: "Sequence[Property]",
            description: str = ''
    ):
        return Instance.create_metadata(
            uri, dimensions, properties, description)

    def __repr__(self):
        return f"<Metadata: uri='{self.uri}'>"

    def getprop(self, name):
        """Returns the metadata property object with the given name."""
        if "properties" not in self.properties:
            raise InvalidMetadataError(
                'self.properties on metadata must contain a "properties" item'
            )
        lst = [p for p in self.properties["properties"] if p.name == name]
        if lst:
            return lst[0]
        raise DLiteError(f"Metadata {self.uri} has no such property: {name}")

    def dimnames(self):
        """Returns a list of all dimension names in this metadata."""
        if "dimensions" not in self.properties:
            return []
        return [d.name for d in self.properties['dimensions']]

    def propnames(self):
        """Returns a list of all property names in this metadata."""
        if "properties" not in self.properties:
            raise InvalidMetadataError(
                'self.properties on metadata must contain a "properties" item'
            )
        return [p.name for p in self.properties['properties']]


def standardise(v, prop, asdict=False):
    """Represent property value `v` as a standard python type.
    If `asdict` is true, dimensions, properties and relations will be
    represented with a dict, otherwise as a list of strings."""
    if asdict:
        conv = lambda x: x.asdict() if hasattr(x, 'asdict') else x
    else:
        conv = lambda x: list(x.asstrings()) if hasattr(x, 'asstrings') else x

    if prop.dtype == BlobType:
        if prop.ndims:
            V = np.fromiter(
                (''.join(f'{c:02x}' for c in s.item()) for s in v.flat),
                dtype=f'U{2*prop.size}')
            V.shape = v.shape
            return V.tolist()
        else:
            return ''.join(f'{c:02x}' for c in v)
    elif hasattr(v, 'tolist'):
        return [conv(x) for x in v.tolist()]
    else:
        return conv(v)


def get_instance(id: "str", metaid: "str" = None, check_storages: "bool" = True) -> "Instance":
    """Return instance with given id.

    Arguments:
        id: ID of instance to return.
        metaid: If given, dlite will try to convert the instance to a new
            instance of ``metaid``.
        check_storages: Whether to check for the instance in storages listed
            in dlite.storage_path if the instance is not already in memory.

    Returns:
        DLite Instance.

    """
    if isinstance(id, Instance):
        inst = id
    else:
        id = str(id).rstrip("#/")
        if metaid and not isinstance(metaid, Instance):
            metaid = str(metaid).rstrip("#/")
        inst = _dlite.get_instance(id, metaid, check_storages)

    if inst is None:
        raise DLiteError(f"no such instance: {id}")
    elif inst.is_meta:
        inst.__class__ = Metadata
    elif inst.meta.uri == COLLECTION_ENTITY:
        inst.__class__ = Collection
    return inst



def _collection_save(coll, s):
    r"""_collection_save(coll, s) -> int"""
    return _dlite._collection_save(coll, s)

def _collection_save_url(coll, url):
    r"""_collection_save_url(coll, url) -> int"""
    return _dlite._collection_save_url(coll, url)

def _collection_add_relation(coll, s, p, o):
    r"""_collection_add_relation(coll, s, p, o) -> int"""
    return _dlite._collection_add_relation(coll, s, p, o)

def _collection_remove_relations(coll, s, p, o):
    r"""_collection_remove_relations(coll, s, p, o) -> int"""
    return _dlite._collection_remove_relations(coll, s, p, o)

def _collection_find_first(coll, s, p, o):
    r"""_collection_find_first(coll, s, p, o) -> Relation"""
    return _dlite._collection_find_first(coll, s, p, o)

def _collection_add(coll, label, inst):
    r"""_collection_add(coll, label, inst) -> int"""
    return _dlite._collection_add(coll, label, inst)

def _collection_remove(coll, label):
    r"""_collection_remove(coll, label) -> int"""
    return _dlite._collection_remove(coll, label)

def _collection_get_new(coll, label, metaid):
    r"""_collection_get_new(coll, label, metaid) -> Instance"""
    return _dlite._collection_get_new(coll, label, metaid)

def _collection_get_id(coll, id):
    r"""_collection_get_id(coll, id) -> Instance"""
    return _dlite._collection_get_id(coll, id)

def _collection_has(coll, label):
    r"""_collection_has(coll, label) -> int"""
    return _dlite._collection_has(coll, label)

def _collection_has_id(coll, id):
    r"""_collection_has_id(coll, id) -> int"""
    return _dlite._collection_has_id(coll, id)

def _collection_count(coll):
    r"""_collection_count(coll) -> int"""
    return _dlite._collection_count(coll)
class _Collection(object):
    r"""Proxy of C _DLiteCollection struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    uuid = property(_dlite._Collection_uuid_get, doc=r"""uuid""")
    uri = property(_dlite._Collection_uri_get, doc=r"""uri""")
    _refcount = property(_dlite._Collection__refcount_get, doc=r"""_refcount""")

    def __init__(self, url=None, storage=None, id=None, lazy=False):
        r"""__init__(self, url=None, storage=None, id=None, lazy=False) -> _Collection"""
        _dlite._Collection_swiginit(self, _dlite.new__Collection(url, storage, id, lazy))
    __swig_destroy__ = _dlite.delete__Collection

    def asinstance(self):
        r"""
        asinstance(self) -> Instance
        Returns a new view of collection as an instance.
        """
        return _dlite._Collection_asinstance(self)

# Register _Collection in _dlite:
_dlite._Collection_swigregister(_Collection)
class _CollectionIter(object):
    r"""Proxy of C _CollectionIter struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    coll = property(_dlite._CollectionIter_coll_get, _dlite._CollectionIter_coll_set, doc=r"""coll""")
    state = property(_dlite._CollectionIter_state_get, _dlite._CollectionIter_state_set, doc=r"""state""")
    s = property(_dlite._CollectionIter_s_get, _dlite._CollectionIter_s_set, doc=r"""s""")
    p = property(_dlite._CollectionIter_p_get, _dlite._CollectionIter_p_set, doc=r"""p""")
    o = property(_dlite._CollectionIter_o_get, _dlite._CollectionIter_o_set, doc=r"""o""")
    rettype = property(_dlite._CollectionIter_rettype_get, _dlite._CollectionIter_rettype_set, doc=r"""rettype""")

    def __init__(self, *args, **kwargs):
        r"""
        __init__(self, inst, s=None, p=None, o=None, rettype='T') -> _CollectionIter
        Iterator over instances in a collection.
        """
        _dlite._CollectionIter_swiginit(self, _dlite.new__CollectionIter(*args, **kwargs))
    __swig_destroy__ = _dlite.delete__CollectionIter

    def next(self):
        r"""
        next(self) -> Instance
        Returns a reference to next matching relation.
        """
        return _dlite._CollectionIter_next(self)

    def next_relation(self):
        r"""next_relation(self) -> Relation"""
        return _dlite._CollectionIter_next_relation(self)

    def poll(self):
        r"""
        poll(self) -> Relation
        Returns reference to the current instance or None if all instances have been visited.
        """
        return _dlite._CollectionIter_poll(self)

    def reset(self):
        r"""
        reset(self)
        Resets the iterator.  The next call to next() will return the first relation.
        """
        return _dlite._CollectionIter_reset(self)

    def __iter__(self):
        return self

    def __next__(self):
        if self.rettype == 'I':  # instance
            v = self.next()
            if v and v.is_meta:
                v.__class__ = Metadata
        elif self.rettype in 'RTspo':  # relation
            v = self.next_relation()
        else:
            raise ValueError('`rettype` must one of "IRTspo"')

        if v is None:
            raise StopIteration()

        if self.rettype == 'T':  # return (s,p,o) tuple
            return (v.s, v.p, v.o)
        elif self.rettype == 's':  # return subject
            return v.s
        elif self.rettype == 'p':  # return predicate
            return v.p
        elif self.rettype == 'o':  # return object
            return v.o

        return v


# Register _CollectionIter in _dlite:
_dlite._CollectionIter_swigregister(_CollectionIter)

def _get_collection(id):
    r"""
    _get_collection(id) -> _Collection
    Returns a new reference to a collection with given id.
    """
    return _dlite._get_collection(id)

from warnings import warn


class Collection(Instance):
    """A collection of instances and relations between them.

    Instances added to a collection are referred to with a label,
    which is local to the collection.

    Iteration over a collection will iterate over the instances added
    to it.  Likewise, the len() of a collection will return the number
    of instances.

    Use the get_relations() method (or the convenience methods
    get_subjects(), get_predicates() and get_predicates()) to iterate
    over relations.  The number of relations is available via the `nrelations`
    property.
    """
    def __new__(cls, id=None):
        """Creates an empty collection."""
        _coll = _Collection(id=id)
        inst = _coll.asinstance()
        inst.__class__ = Collection
        return inst

    def __init__(self, id=None):
        pass  # avoid calling Instance.__init__()

    @classmethod
    def load(cls, src, location=None, options=None, id=None, lazy=True):
        """Loads a collection from storage.

        Arguments:
            src: Storage instance | url | driver
            location: str
                File path to load from when `src` is a driver.
            options: str
                Options passed to the storage plugin when `src` is a driver.
            id: str
                Id of collection to load.  Needed if there are more than
                one instance in the storage.
            lazy: bool
                Whether to also save all instances referred to by the
                collection.
        """
        if isinstance(src, Storage):
            _coll = _Collection(storage=src, id=id, lazy=bool(lazy))
        elif location:
            with Storage(src, location, options) as s:
                _coll = _Collection(storage=s, id=id, lazy=bool(lazy))
        else:
            _coll = _Collection(url=src, lazy=bool(lazy))
        inst = _coll.asinstance()
        inst.__class__ = Collection
        return inst

    def save(self, dst, location=None, options=None, include_instances=True):
        """Save collection.

        Arguments:
            dst: Storage instance | url | driver
            location: str
                File path to write to when `dst` is a driver.
            options: str
                Options passed to the storage plugin when `dst` is a driver.
            include_instances: bool
                Whether to also save all instances referred to by the
                collection.
        """
        loc = str(location) if location else None
        if include_instances:
            c = self._coll
            if isinstance(dst, Storage):
                _collection_save(c, dst)
            elif location:
                with Storage(dst, loc, options) as s:
                    _collection_save(c, s)
            else:
                _collection_save_url(c, dst)
        elif isinstance(dst, Storage):
            Instance.save(self, storage=dst)
        else:
            Instance.save(self, dst, loc, options)

    _coll = property(
        lambda self: _get_collection(id=self.uuid),
        doc='SWIG-internal representation of this collection.')

    properties = property(
        lambda self: {'relations': list(self.get_relations())},
        doc='Dictionary with property name-value pairs.')

    def __repr__(self):
        return '<Collection: %s>' % (
            f"uri='{self.uri}'" if self.uri else f"uuid='{self.uuid}'")

    def __iter__(self):
        return _CollectionIter(self, rettype='I')

    def __len__(self):
        return _collection_count(self._coll)

    def __getitem__(self, label):
        return self.get(label)

    def __setitem__(self, label, inst):
        self.add(label, inst)

    def __delitem__(self, label):
        self.remove(label)

    def __contains__(self, label):
        return self.has(label)

    def add(self, label, inst, force=False):
        """Add `inst` to collection with given label.
        If `force` is true, a possible existing instance will be replaced.
        """
        if force and self.has(label):
            self.remove(label)
        _collection_add(self._coll, label, inst)

    def remove(self, label):
        """Remove instance with given label from collection."""
        if _collection_remove(self._coll, label):
            raise DLiteError(f'No such label in collection: "{label}"')

    def get(self, label, metaid=None):
        """Return instance with given label.

        If `metaid` is given, the instance is converted to an instance
        of `metaid` using instance mappings.  If no such instance mapping
        is registered, a DLiteError is raised.
        """
        return _collection_get_new(self._coll, label, metaid)

    def get_id(self, id):
        """Return instance with given id."""
        inst = _collection_get_id(self._coll, id)
        return inst

    def has(self, label):
        """Returns true if an instance has been added with the given label."""
        b = _collection_has(self._coll, label)
        return bool(b)

    def has_id(self, id):
        """Returns true if an instance has been added with the given id."""
        b = _collection_has_id(self._coll, id)
        return bool(b)

    def add_relation(self, s, p, o):
        """Add (subject, predicate, object) RDF triple to collection."""
        if _collection_add_relation(self._coll, s, p, o) != 0:
            raise DLiteError(f'Error adding relation ({s}, {p}, {o})')

    def remove_relations(self, s=None, p=None, o=None):
        """Remove all relations matching `s`, `p` and `o`."""
        if _collection_remove_relations(self._coll, s, p, o) < 0:
            raise DLiteError(
                f'Error removing relations matching ({s}, {p}, {o})')

    def get_first_relation(self, s=None, p=None, o=None):
        """Returns the first relation matching `s`, `p` and `o`.
        None is returned if there are no matching relations."""
        return _collection_find_first(self._coll, s, p, o)

    def get_instances(self, metaid=None, property_mappings=False,
                      allow_incomplete=False, ureg=None, function_repo=None,
                      **kwargs):
        """Returns a generator over all instances in collection.

        Arguments:
            metaid: If given, only instances of this metadata will be
                returned.
            property_mappings: Whether to also iterate over new instances
                of type `metaid` instantiated from property mappings.
                Hence, if `property_mappings` is true, `metaid` is required.
            allow_incomplete: Allow "incomplete" property mappings.
                Properties with no mappings will be initialised to zero.
            ureg: Optional custom Pint unit registry.  By default the builtin
                Pint unit registry is used.
            function_repo: Repository for mapping functions.  Should map
                function IRIs to function implementations.
            kwargs: Additional keyword arguments passed to mapping_route().
        """
        iter = _CollectionIter(self, s=None, p=None, o=None, rettype='I')
        if metaid:
            if hasattr(metaid, "uri"):
                uri = metaid.uri
            else:
                uri = str(metaid).rstrip("#/")

            for inst in iter:
                if inst.meta.uri == uri:
                    yield inst

            if property_mappings:
# This import must be here to avoid circular imports
# -- consider refacturing.
                from dlite.mappings import instantiate_all

                try:
                    import pint
                    from tripper import Namespace, Triplestore
                except ImportError as exc:
                    raise ImportError(
                        "Property mappings require tripper and pint. "
                        "Please do:\n\n"
                        "    pip install pint tripper\n"
                    ) from exc

                meta = metaid if isinstance(
                    metaid, Instance) else _dlite.get_instance(
                        str(metaid).rstrip("#/"))
                if not meta:
                    raise TypeError(f"cannot instantiate metadata: {metaid}")
                if meta.is_meta:
                    meta.__class__ = Metadata

                if ureg is None:
                    quantity = pint.Quantity
                elif isinstance(ureg, pint.UnitRegistry):
                    quantity = ureg.Quantity
                elif isinstance(ureg, pint.Quantity):
                    quantity = ureg
                else:
                    raise TypeError(
                        '`ureg` must be a Pint unit registry or Quantity '
                        'class')

                ts = Triplestore(backend='collection', collection=self)
                if function_repo:
                    ts.function_repo.update(function_repo)

                for inst in instantiate_all(
                    meta=meta,
                    instances=list(self.get_instances()),
                    triplestore=ts,
                    allow_incomplete=allow_incomplete,
                    quantity=quantity,
                    **kwargs
                ):
                    yield inst
        elif property_mappings:
            raise DLiteError(
                '`metaid` is required when `property_mappings` is true')
        else:
            for inst in iter:
                yield inst

    def get_labels(self):
        """Returns a generator over all labels."""
        return self.get_subjects(p='_is-a', o='Instance')

    def get_relations(self, s=None, p=None, o=None, rettype='T'):
        """Returns a generator over all relations matching the given
        values of `s`, `p` and `o`."""
        return _CollectionIter(self, s=s, p=p, o=o, rettype=rettype)

    def get_subjects(self, p=None, o=None):
        """Returns a generator over all subjects of relations matching the
        given values of `p` and `o`."""
        return _CollectionIter(self, s=None, p=p, o=o, rettype='s')

    def get_predicates(self, s=None, o=None):
        """Returns a generator over all predicates of relations matching the
        given values of `s` and `o`."""
        return _CollectionIter(self, s=s, p=None, o=o, rettype='p')

    def get_objects(self, s=None, p=None):
        """Returns a generator over all subjects of relations matching the
        given values of `s` and `p`."""
        return _CollectionIter(self, s=s, p=p, o=None, rettype='o')


def get_collection(id):
    """Returns a new reference to a collection with given id."""
    warn("dlite.get_collection() is deprecated.  "
         "Use dlite.get_instance() instead",
         DeprecationWarning, stacklevel=2)
    _coll = _get_collection(id=id)
    inst = _coll.asinstance()
    inst.__class__ = Collection
    return inst


class FUPath(object):
    r"""Proxy of C _FUPaths struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    n = property(_dlite.FUPath_n_get, doc=r"""n""")

    def __init__(self, pathtype):
        r"""
        __init__(self, pathtype) -> FUPath
        Creates a _Path instance of type `pathtype`.

        """
        _dlite.FUPath_swiginit(self, _dlite.new_FUPath(pathtype))
    __swig_destroy__ = _dlite.delete_FUPath

    def __repr__(self):
        r"""__repr__(self) -> char *"""
        return _dlite.FUPath___repr__(self)

    def __len__(self):
        r"""__len__(self) -> int"""
        return _dlite.FUPath___len__(self)

    def getitem(self, index):
        r"""getitem(self, index) -> char const *"""
        return _dlite.FUPath_getitem(self, index)

    def __setitem__(self, index, path):
        r"""__setitem__(self, index, path)"""
        return _dlite.FUPath___setitem__(self, index, path)

    def __delitem__(self, index):
        r"""__delitem__(self, index)"""
        return _dlite.FUPath___delitem__(self, index)

    def insert(self, index, path):
        r"""insert(self, index, path)"""
        return _dlite.FUPath_insert(self, index, path)

    def append(self, path):
        r"""append(self, path)"""
        return _dlite.FUPath_append(self, path)

    def extend(self, paths, pathsep=None):
        r"""extend(self, paths, pathsep=None)"""
        return _dlite.FUPath_extend(self, paths, pathsep)

    def get_platform(self):
        r"""get_platform(self) -> char const *"""
        return _dlite.FUPath_get_platform(self)

    def set_platform(self, platform):
        r"""set_platform(self, platform)"""
        return _dlite.FUPath_set_platform(self, platform)

    def __contains__(self, value):
        return value in self.aslist()

    def __getitem__(self, key):
        n = len(self)
        if key < 0:
            key += n
        if key < 0 or key >= n:
            raise IndexError(f'key out of range: {key}')
        return self.getitem(key)

    def __iter__(self):

        class Iter:
            def __init__(slf):
                slf.n = 0
            def __next__(slf):
                if slf.n < len(self):
                    path = self[slf.n]
                    slf.n += 1
                    return path
                else:
                    raise StopIteration()

        return Iter()

    def aslist(self):
        return [self[i] for i in range(len(self))]



# Register FUPath in _dlite:
_dlite.FUPath_swigregister(FUPath)

storage_path = FUPath("storages")
storage_plugin_path = FUPath("storage-plugins")
mapping_plugin_path = FUPath("mapping-plugins")
python_storage_plugin_path = FUPath("python-storage-plugins")
python_mapping_plugin_path = FUPath("python-mapping-plugins")



def mapping(output_uri, instances):
    r"""
    mapping(output_uri, instances) -> Instance
      Returns a new instance of metadata `output_uri` by mapping the
      input instances.

    """
    return _dlite.mapping(output_uri, instances)

def python_mapping_unload():
    r"""
    python_mapping_unload()
      Unloads all currently loaded mappings.

    """
    return _dlite.python_mapping_unload()

def mapping_plugin_unload(name=None):
    r"""mapping_plugin_unload(name=None) -> int"""
    return _dlite.mapping_plugin_unload(name)

